// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Definicin de la clase Casilla

#include "casilla.h"

extern void Texto(int f, int c, const char *texto, WORD color);

Casilla::Casilla(int f=0, int c=0, int v=0, bool ini=true) :
    fila(f), columna(c), caja((f/3)*3+c/3), pos((fila%3)*3+columna%3), valor(v), posible(false), inicial(ini) {

    for(int i=0; i<9; i++) lapiz[i] = false;
}

void Casilla::Asignar(int v) {
    valor = v;
    for(int v=1; v<=9; v++) DesmarcaLapiz(v);
}

// Asigna la marca de lpiz correspondiente al valor v.
// Retorna true si se aade informacin.
bool Casilla::MarcaLapiz(int v) {
    if(lapiz[v-1]) return false;
    lapiz[v-1] = true;
    return true;
}

// Elimina la marca de lpiz correspondiente al valor v.
// Retorna true si se aade informacin.
bool Casilla::DesmarcaLapiz(int v) {
    if(!lapiz[v-1]) return false;
    lapiz[v-1] = false;
    return true;
}

int Casilla::NumeroMarcasLapiz() const {
    int n=0;

    for(int v=1; v<=9; v++) if(Lapiz(v)) n++;
    return n;
}

void Casilla::Mostrar() {
    char C[2]=" ";
    int v;
    WORD color=0;

    if(!posible)
        color = BACKGROUND_GREEN;// | BACKGROUND_INTENSITY

    if(resaltar)
        color = BACKGROUND_BLUE;// | BACKGROUND_INTENSITY;

    if(valor) {
        color |= FOREGROUND_RED | FOREGROUND_BLUE | FOREGROUND_GREEN;
        if(inicial) color |= FOREGROUND_INTENSITY;
    } else {
        color |= FOREGROUND_INTENSITY | FOREGROUND_RED;
    }
    v=1;
    for(int i=1; i<=3; i++) {
        for(int j=1; j<=3; j++) {
            if(Lapiz(v)) C[0] = '0'+v; else C[0] = ' ';
            Texto(fila*4+i, columna*4+j, C, color);
            v++;
        }
    }

    if(valor) {
        C[0] = '0'+Valor();
        Texto(fila*4+2, columna*4+2, C, color);
    }
}


