// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase Casilla

#ifndef SUDOKU_CASILLA
#define SUDOKU_CASILLA
#include <windows.h>

class Casilla {
    private:
    int fila,columna,caja,pos;
    int valor;
    bool posible;
    bool inicial;
    bool resaltar;
    bool lapiz[9];

    public:
    Casilla() : fila(), columna(0), valor(0), inicial(false) {}
    Casilla(int f, int c, int v, bool ini);
    int Valor() const { return valor; }
    void Asignar(int v);
    int Fila() const { return fila; }
    int Columna() const { return columna; }
    int Caja() const { return caja; }
    int PosEnCaja() const { return pos; }
    bool Posible() const { return posible; }
    void Resaltar(bool r=true) { resaltar = r; }
    void MarcaPosible( bool p=true ) { posible = p; }
    void MarcaNoPosible() { posible = false; }
    bool MarcaLapiz(int v);
    bool DesmarcaLapiz(int v);
    bool Lapiz(int v) const { return lapiz[v-1]; }
    int NumeroMarcasLapiz() const;
    void Mostrar();
};
#endif // SUDOKU_CASILLA
